#![allow(dead_code)]

pub mod brain {
    tonic::include_proto!("brain");
}

use crate::data::BrainData;
use brain::brain_cli_service_server::BrainCliService;
use brain::brain_daemon_service_server::BrainDaemonService;
use brain::*;
use std::pin::Pin;
use std::sync::Arc;
use tokio_stream::Stream;
use tonic::{Request, Response, Status, Streaming};

struct BrainDaemonMock {
    data: Arc<BrainData>,
}
struct BrainCliMock {
    data: Arc<BrainData>,
}

#[tonic::async_trait]
impl BrainDaemonService for BrainDaemonMock {
    async fn register_node(
        &self,
        _req: Request<RegisterNodeRequest>,
    ) -> Result<Response<Empty>, Status> {
        todo!()
    }

    type NewVMUpdatesStream = Pin<Box<dyn Stream<Item = Result<NewVmRequest, Status>> + Send>>;

    async fn new_vm_updates(
        &self,
        _req: Request<Streaming<NewVmConfirmation>>,
    ) -> Result<Response<Self::NewVMUpdatesStream>, Status> {
        todo!()
    }

    type DeletedVMUpdatesStream =
        Pin<Box<dyn Stream<Item = Result<DeletedVmUpdate, Status>> + Send>>;

    async fn deleted_vm_updates(
        &self,
        _req: Request<Empty>,
    ) -> Result<Response<Self::DeletedVMUpdatesStream>, Status> {
        todo!()
    }

    type ListVMContractsStream = Pin<Box<dyn Stream<Item = Result<VmContract, Status>> + Send>>;

    async fn list_vm_contracts(
        &self,
        _req: Request<Empty>,
    ) -> Result<Response<Self::ListVMContractsStream>, Status> {
        todo!()
    }
}

#[tonic::async_trait]
impl BrainCliService for BrainCliMock {
    async fn create_vm_contract(
        &self,
        _req: Request<NewVmRequest>,
    ) -> Result<Response<NewVmConfirmation>, Status> {
        todo!();
    }

    type ListVMContractsStream = Pin<Box<dyn Stream<Item = Result<VmContract, Status>> + Send>>;
    async fn list_vm_contracts(
        &self,
        _req: Request<Empty>,
    ) -> Result<Response<Self::ListVMContractsStream>, Status> {
        todo!()
    }

    type ListNodesStream = Pin<Box<dyn Stream<Item = Result<NodeListResponse, Status>> + Send>>;
    async fn list_nodes(
        &self,
        _req: Request<NodeFilters>,
    ) -> Result<Response<Self::ListNodesStream>, tonic::Status> {
        todo!()
    }
}
